#!/usr/bin/perl

use Net::SNMP;
use Getopt::Long;

sub procesar_argumentos(){
	$status = GetOptions(
		"h=s" => \$ip,		"ip=s" => \$ip,
		"p=i" => \$interfaz, 	"interfaz=i" => \$interfaz,
		"c=s" => \$comunidad,	"comunidad=s" => \$comunidad,
	);
}
$paquetes_perdidos;
$paquetes_entrantes;
@datos_T1;
procesar_argumentos();
$fichero = $ip.':'.$interfaz.':paq';

if (-e $fichero)
	{
	# Ejecucion normal, ya tenemos referencias anteriores
	# Paquetes descartados
	my $oid = '.1.3.6.1.2.1.2.2.1.13.'.$interfaz;
	my $host = $ip;
	my $community = $comunidad;
	my ($session, $error) = Net::SNMP->session(-hostname => $host, -community => $community);
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}
	
	my $paquetes_descartados = $result->{$oid};

	# Paquetes erroneos
	my $oid = '1.3.6.1.2.1.2.2.1.14.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}

	my $paquetes_erroneos = $result->{$oid};

	# Paquetes desconocidos
	my $oid = '.1.3.6.1.2.1.2.2.1.15.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}

	my $paquetes_desconocidos = $result->{$oid};

	$paquetes_perdidos = $paquetes_descartados + $paquetes_erroneos + $paquetes_desconocidos;
	
	# Paquetes entrantes unicast
	my $oid = '.1.3.6.1.2.1.2.2.1.11.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}
	my $paquetes_unicast = $result->{$oid};
	
	# Paquetes entrantes no-unicast
	my $oid = '.1.3.6.1.2.1.2.2.1.12.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}
	my $paquetes_no_unicast = $result->{$oid};
	$session->close();

	$paquetes_entrantes = $paquetes_unicast + $paquetes_no_unicast;
	
	open (fichero, $fichero) || die "no se puede abrir el fichero.\n";
	my $line = <fichero>;
	close fichero;
	print @line;
	@datos_T1 = split(/;/, $line);

	}
	else
	{
	# Es la primera ejecucion
	# Paquetes descartados
	my $oid = '.1.3.6.1.2.1.2.2.1.13.'.$interfaz;
	my $host = $ip;
	my $community = $comunidad;
	my ($session, $error) = Net::SNMP->session(-hostname => $host, -community => $community);
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}

	my $paquetes_descartados = $result->{$oid};

	# Paquetes erroneos
	my $oid = '.1.3.6.1.2.1.2.2.1.14.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}

	my $paquetes_erroneos = $result->{$oid};

	# Paquetes desconocidos
	my $oid = '.1.3.6.1.2.1.2.2.1.15.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}

	my $paquetes_desconocidos = $result->{$oid};

	$paquetes_perdidos = $paquetes_descartados + $paquetes_erroneos + $paquetes_desconocidos;

	# Paquetes entrantes unicast
	my $oid = '.1.3.6.1.2.1.2.2.1.11.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}

	my $paquetes_unicast = $result->{$oid};

	# Paquetes entrantes no-unicast
	my $oid = '.1.3.6.1.2.1.2.2.1.12.'.$interfaz;
	my $result = $session->get_request(-varbindlist => [$oid],);

	if (!defined $result){
		printf "ERROR: %s.\n", $session->error();
		$session->close();
		exit 1;
	}

	my $paquetes_no_unicast = $result->{$oid};

	$paquetes_entrantes = $paquetes_unicast + $paquetes_no_unicast;
	
	$session->close();

	open(fichero, '>'.$fichero) || die "no se puede abrir el fichero\n";
	push (@datos, $paquetes_perdidos);
	push (@datos, $paquetes_entrantes);
	my @registro = join (";", @datos);
	print fichero "@registro\n";
	close fichero;
	print 0;
	exit 0;
	}

	open (fichero, '>'.$fichero) || die "no se puede abrir el fichero.\n";
	push (@datos, $paquetes_perdidos);
	push (@datos, $paquetes_entrantes);
	my @registro = join (";", @datos);
	print fichero "@registro\n";
	close fichero;
	# Calculamos el porcentaje de perdidas
	$incremento_perdidos = $paquetes_perdidos - $datos_T1[0];
	$incremento_entrantes = $paquetes_entrantes - $datos_T1[1];
	
	#Evitar divisiones por cero
	if ($incremento_entrantes != 0) {
		$perdidos = $incremento_perdidos / $incremento_entrantes;
	} else {
		$perdidos = 0;
	}
	
	if ($perdidos < 0) { print 0; }
	else { print $perdidos; }
